Summary:	HTTP request/response parser for C
Summary(pl.UTF-8):	Analizator żądań/odpowiedzi HTTP dla C
Name:		http-parser
Version:	2.9.2
Release:	2
License:	MIT
Group:		Libraries
#Source0Download: https://github.com/nodejs/http-parser/releases
Source0:	https://github.com/nodejs/http-parser/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	aaf0421392e1c0d1f2d51ec9f0e08cc1
# Build shared library with SONAME using gyp and remove -O flags so optflags take over
# TODO: do this nicely upstream
Patch0:		%{name}-gyp-sharedlib.patch
URL:		http://github.com/nodejs/http-parser
BuildRequires:	libstdc++-devel
BuildRequires:	gyp
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# we use the upstream version from http_parser.h as the SONAME
%define somajor 2
%define sominor 9
%define somicro 2

%description
This is a parser for HTTP messages written in C. It parses both
requests and responses. The parser is designed to be used in
performance HTTP applications. It does not make any syscalls nor
allocations, it does not buffer data, it can be interrupted at
anytime. Depending on your architecture, it only requires about 40
bytes of data per message stream (in a web server that is per
connection).

%description -l pl.UTF-8
Ten pakiet zawiera analizator komunikatów HTTP napisany w C. Analizuje
zarówno żądania, jak i odpowiedzi. Może być używany w zastosowaniach
wymagających dużej wydajności. Nie wykonuje żadnych wywołań
systemowych, nie przydziela pamięci, nie buforuje danych, może być
przerwany w dowolnej chwili. W zależności od architektury wymaga
jedynie około 40 bajtów danych dla strumienia komunikatów (w przypadku
serwera WWW - dla połączenia).

%package devel
Summary:	Development headers for http-parser library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki http-parser
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Development headers for http-parser library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki http-parser.

%prep
%setup -q
%patch0

%build
# TODO: fix -fPIC upstream
export CFLAGS='%{rpmcflags} -fPIC'
gyp -f make --depth=. http_parser.gyp
%{__make} V=1 \
	CC="%{__cc}" \
	CXX="%{__cxx}" \
	BUILDTYPE=Release

%if %{with tests}
export LD_LIBRARY_PATH='./out/Release/lib.target'
./out/Release/test-nonstrict
./out/Release/test-strict
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_libdir},%{_includedir}}
cp -p http_parser.h $RPM_BUILD_ROOT%{_includedir}

# install regular variant
install -p out/Release/lib.target/libhttp_parser.so.%{somajor} $RPM_BUILD_ROOT%{_libdir}/libhttp_parser.so.%{somajor}.%{sominor}.%{somicro}
lib=$(basename $RPM_BUILD_ROOT%{_libdir}/libhttp_parser.so.*.*.*)
ln -s $lib $RPM_BUILD_ROOT%{_libdir}/libhttp_parser.so.%{somajor}
ln -s $lib $RPM_BUILD_ROOT%{_libdir}/libhttp_parser.so

# install strict variant
install -p out/Release/lib.target/libhttp_parser_strict.so.%{somajor} $RPM_BUILD_ROOT%{_libdir}/libhttp_parser_strict.so.%{somajor}.%{sominor}.%{somicro}
lib=$(basename $RPM_BUILD_ROOT%{_libdir}/libhttp_parser_strict.so.*.*.*)
ln -s $lib $RPM_BUILD_ROOT%{_libdir}/libhttp_parser_strict.so.%{somajor}
ln -s $lib $RPM_BUILD_ROOT%{_libdir}/libhttp_parser_strict.so

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS LICENSE-MIT README.md
%attr(755,root,root) %{_libdir}/libhttp_parser.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libhttp_parser.so.2
%attr(755,root,root) %{_libdir}/libhttp_parser_strict.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libhttp_parser_strict.so.2

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libhttp_parser.so
%attr(755,root,root) %{_libdir}/libhttp_parser_strict.so
%{_includedir}/http_parser.h
%changelog
* Tue Jun 11 2019 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/http-parser.git;a=log;h=master

* Mon Jun 03 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> 1c544ab
- release 2 (by relup.sh)

* Sun May 26 2019 Jakub Bogusz <qboosh@pld-linux.org> a4dd283
- updated to 2.9.2

* Fri Oct 19 2018 Jakub Bogusz <qboosh@pld-linux.org> 91ae93d
- updated to 2.8.1

* Thu Feb 15 2018 Jakub Bogusz <qboosh@pld-linux.org> 3f5545e
- updated to 2.8.0

* Wed Dec 07 2016 Jakub Bogusz <qboosh@pld-linux.org> 5d0c3a9
- updated URLs, up to 2.7.1

* Sun Jun 26 2016 Jakub Bogusz <qboosh@pld-linux.org> e23bdc9
- updated to 2.7.0

* Wed Sep 30 2015 Jakub Bogusz <qboosh@pld-linux.org> 679d86f
- updated to 2.5.0

* Tue Mar 03 2015 Jakub Bogusz <qboosh@pld-linux.org> 33618b3
- updated to 2.4.2

* Mon Jun 23 2014 Jakub Bogusz <qboosh@pld-linux.org> b4f3ee6
- updated to 2.3

* Sat Mar 01 2014 Elan Ruusamäe <glen@delfi.ee> 4cd9432
- up to 2.2

* Sat Mar 01 2014 Elan Ruusamäe <glen@delfi.ee> 883d3df
- up to 2.1

* Sun Jul 21 2013 Jakub Bogusz <qboosh@pld-linux.org> 1961ec0
- pl, cleanup

* Sun Apr 07 2013 Elan Ruusamäe <glen@delfi.ee> 1dcbed4
- BR: libstdc++-devel

* Sun Apr 07 2013 Elan Ruusamäe <glen@delfi.ee> 2889eff
- new, version 2.0

